common: add cifs support
[xfstests-dev.git] / common / config
1 ##/bin/bash
2 #
3 # Copyright (c) 2000-2003,2006 Silicon Graphics, Inc.  All Rights Reserved.
4 #
5 # This program is free software; you can redistribute it and/or
6 # modify it under the terms of the GNU General Public License as
7 # published by the Free Software Foundation.
8 #
9 # This program is distributed in the hope that it would be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write the Free Software Foundation,
16 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
17 #
18 #
19 # setup and check for config parameters, and in particular
20 #
21 # EMAIL -           email of the script runner.
22 # TEST_DIR -        scratch test directory that is in an already
23 #                   mounted XFS file system, needs to be be world
24 #                   writeable
25 # TEST_DEV -        device for file system containing TEST_DIR
26 #
27 # and optionally:
28 # SCRATCH_DEV -     device you can make a scratch file system on
29 # SCRATCH_MNT -     mount point for scratch file system
30 # SCRATCH_LOGDEV -  scratch log device for external log testing
31 # SCRATCH_RTDEV -   scratch rt dev
32 # TEST_LOGDEV -     test log device for external log testing
33 # TEST_RTDEV -      test rt dev
34 # TAPE_DEV -        the tape device for the xfsdump tests
35 # RMT_TAPE_DEV -    the remote tape device for the xfsdump tests
36 # RMT_IRIXTAPE_DEV- the IRIX remote tape device for the xfsdump tests
37 # RMT_TAPE_USER -   remote user for tape device
38 #
39 # - These can be added to $HOST_CONFIG_DIR (witch default to ./config)
40 #   below or a separate local configuration file can be used (using
41 #   the HOST_OPTIONS variable).
42 # - This script is shared by the stress test system and the auto-qa
43 #   system
44 # - TEST_DEV & TEST_DIR must be assigned.
45 # - this script shouldn't make any assertions about filesystem
46 #   validity or mountedness.
47 #
48
49 # all tests should use a common language setting to prevent golden
50 # output mismatches.
51 export LANG=C
52 export LC_ALL=C
53
54 # Warning: don't put freeware before /usr/bsd on IRIX coz you'll
55 #  get the wrong hostname and set your system name to -s  :)
56 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
57 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
58 PATH=".:$PATH"
59
60 export HOST=`hostname -s`
61 export HOSTOS=`uname -s`
62 [ "$HOSTOS" = "IRIX64" ] && export HOSTOS="IRIX"
63
64 export MODULAR=0               # using XFS as a module or not
65 export BOOT="/boot"            # install target for kernels
66 export EXTRA=${EXTRA:=xfs-qa}
67
68 # general parameters (mainly for auto-qa)
69 export SOAK_PROC=3             # -p option to fsstress
70 export SOAK_STRESS=10000       # -n option to fsstress
71 export SOAK_PASSES=-1          # count of repetitions of fsstress (while soaking)
72 export EMAIL=root@localhost    # where auto-qa will send its status messages
73 export HOST_OPTIONS=${HOST_OPTIONS:=local.config}
74 export CHECK_OPTIONS=${CHECK_OPTIONS:="-g auto"}
75 export BENCH_PASSES=${BENCH_PASSES:=5}
76 export XFS_MKFS_OPTIONS=${XFS_MKFS_OPTIONS:=-bsize=4096}
77 export TIME_FACTOR=${TIME_FACTOR:=1}
78 export LOAD_FACTOR=${LOAD_FACTOR:=1}
79 export DEBUGFS_MNT=${DEBUGFS_MNT:="/sys/kernel/debug"}
80
81 export PWD=`pwd`
82 #export DEBUG=${DEBUG:=...} # arbitrary CFLAGS really.
83 export MALLOCLIB=${MALLOCLIB:=/usr/lib/libefence.a}
84 export LOCAL_CONFIGURE_OPTIONS=${LOCAL_CONFIGURE_OPTIONS:=--enable-readline=yes}
85
86 export RECREATE_TEST_DEV=false
87
88 # $1 = prog to look for, $2* = default pathnames if not found in $PATH
89 set_prog_path()
90 {
91     p=`which $1 2> /dev/null`
92     if [ -n "$p" -a -x "$p" ]; then
93         echo $p
94         return 0
95     fi
96     p=$1
97
98     shift
99     for f; do
100         if [ -x $f ]; then
101             echo $f
102             return 0
103         fi
104     done
105
106     echo ""
107     return 1
108 }
109
110 # Handle mkfs.btrfs which does (or does not) require -f to overwrite
111 set_btrfs_mkfs_prog_path_with_opts()
112 {
113         p=`set_prog_path mkfs.btrfs`
114         if [ "$p" != "" ] && grep -q 'force overwrite' $p; then
115                 echo "$p -f"
116         else
117                 echo $p
118         fi
119 }
120
121 _fatal()
122 {
123     echo "$*"
124     status=1
125     exit 1
126 }
127
128 export MKFS_PROG="`set_prog_path mkfs`"
129 [ "$MKFS_PROG" = "" ] && _fatal "mkfs not found"
130
131 export MOUNT_PROG="`set_prog_path mount`"
132 [ "$MOUNT_PROG" = "" ] && _fatal "mount not found"
133
134 export UMOUNT_PROG="`set_prog_path umount`"
135 [ "$UMOUNT_PROG" = "" ] && _fatal "umount not found"
136
137 export FSSTRESS_PROG="./ltp/fsstress"
138 [ "$FSSTRESS_PROG" = "" ] && _fatal "fsstress not found"
139
140 export PERL_PROG="`set_prog_path perl`"
141 [ "$PERL_PROG" = "" ] && _fatal "perl not found"
142
143 export AWK_PROG="`set_prog_path awk`"
144 [ "$AWK_PROG" = "" ] && _fatal "awk not found"
145
146 export SED_PROG="`set_prog_path sed`"
147 [ "$SED_PROG" = "" ] && _fatal "sed not found"
148
149 export BC_PROG="`set_prog_path bc`"
150 [ "$BC_PROG" = "" ] && _fatal "bc not found"
151
152 export PS_ALL_FLAGS="-ef"
153
154 export DF_PROG="`set_prog_path df`"
155 [ "$DF_PROG" = "" ] && _fatal "df not found"
156 [ "$HOSTOS" = "Linux" ] && export DF_PROG="$DF_PROG -T -P"
157
158 export XFS_LOGPRINT_PROG="`set_prog_path xfs_logprint`"
159 export XFS_REPAIR_PROG="`set_prog_path xfs_repair`"
160 export XFS_DB_PROG="`set_prog_path xfs_db`"
161 export XFS_GROWFS_PROG=`set_prog_path xfs_growfs`
162 export XFS_IO_PROG="`set_prog_path xfs_io`"
163 export XFS_PARALLEL_REPAIR_PROG="`set_prog_path xfs_prepair`"
164 export XFS_PARALLEL_REPAIR64_PROG="`set_prog_path xfs_prepair64`"
165 export __XFSDUMP_PROG="`set_prog_path xfsdump`"
166 export XFSDUMP_PROG="$__XFSDUMP_PROG -e"
167 export XFSRESTORE_PROG="`set_prog_path xfsrestore`"
168 export XFSINVUTIL_PROG="`set_prog_path xfsinvutil`"
169 export GETFATTR_PROG="`set_prog_path getfattr`"
170 export SETFATTR_PROG="`set_prog_path setfattr`"
171 export CHACL_PROG="`set_prog_path chacl`"
172 export ATTR_PROG="`set_prog_path attr`"
173 export QUOTA_PROG="`set_prog_path quota`"
174 export XFS_QUOTA_PROG="`set_prog_path xfs_quota`"
175 export KILLALL_PROG="`set_prog_path killall`"
176 export INDENT_PROG="`set_prog_path indent`"
177 export XFS_COPY_PROG="`set_prog_path xfs_copy`"
178 export FSTRIM_PROG="`set_prog_path fstrim`"
179 export DUMPE2FS_PROG="`set_prog_path dumpe2fs`"
180 export FIO_PROG="`set_prog_path fio`"
181 export FILEFRAG_PROG="`set_prog_path filefrag`"
182 export E4DEFRAG_PROG="`set_prog_path e4defrag`"
183 export LOGGER_PROG="`set_prog_path logger`"
184 export DBENCH_PROG="`set_prog_path dbench`"
185 export DMSETUP_PROG="`set_prog_path dmsetup`"
186 export WIPEFS_PROG="`set_prog_path wipefs`"
187
188 # Generate a comparable xfsprogs version number in the form of
189 # major * 10000 + minor * 100 + release
190 #
191 # $ xfs_db -V
192 # xfs_db version 2.9.7
193 #
194 # so, 2.9.7 = 20907
195 _version=`$XFS_DB_PROG -V | $AWK_PROG '
196         /version/ {
197                 if (split($3,ver,".") == 3)
198                         print (ver[1] * 10000) + (ver[2] * 100) + ver[3];
199         }'`
200 [ -z "$_version" ] && _fatal "xfsprogs version cannot be found"
201 export XFSPROGS_VERSION="$_version"
202
203 case "$HOSTOS" in
204     IRIX*)
205         export MKFS_XFS_PROG="`set_prog_path mkfs_xfs`"
206         export MKFS_UDF_PROG="`set_prog_path mkfs_udf`"
207         export XFS_FSR_PROG="`set_prog_path /usr/etc/fsr_xfs`"
208         export MKFS_NFS_PROG="false"
209         export MKFS_CIFS_PROG="false"
210         ;;
211     Linux)
212         export MKFS_XFS_PROG="`set_prog_path mkfs.xfs`"
213         export MKFS_UDF_PROG="`set_prog_path mkudffs`"
214         export MKFS_BTRFS_PROG="`set_btrfs_mkfs_prog_path_with_opts`"
215         export BTRFS_UTIL_PROG="`set_prog_path btrfs`"
216         export BTRFS_SHOW_SUPER_PROG="`set_prog_path btrfs-show-super`"
217         export XFS_FSR_PROG="`set_prog_path xfs_fsr`"
218         export MKFS_NFS_PROG="false"
219         export MKFS_CIFS_PROG="false"
220         ;;
221 esac
222
223 # SELinux adds extra xattrs which can mess up our expected output.
224 # So, mount with a context, and they won't be created
225 # # nfs_t is a "liberal" context so we can use it.
226 if [ -x /usr/sbin/selinuxenabled ] && /usr/sbin/selinuxenabled; then
227         SELINUX_MOUNT_OPTIONS="-o context=system_u:object_r:nfs_t:s0"
228         export SELINUX_MOUNT_OPTIONS
229 fi
230
231 _mount_opts()
232 {
233         case $FSTYP in
234         xfs)
235                 export MOUNT_OPTIONS=$XFS_MOUNT_OPTIONS
236                 ;;
237         udf)
238                 export MOUNT_OPTIONS=$UDF_MOUNT_OPTIONS
239                 ;;
240         nfs)
241                 export MOUNT_OPTIONS=$NFS_MOUNT_OPTIONS
242                 ;;
243         cifs)
244                 export MOUNT_OPTIONS=$CIFS_MOUNT_OPTIONS
245                 ;;
246         ext2|ext3|ext4|ext4dev)
247                 # acls & xattrs aren't turned on by default on ext$FOO
248                 export MOUNT_OPTIONS="-o acl,user_xattr $EXT_MOUNT_OPTIONS"
249                 ;;
250         reiserfs)
251                 # acls & xattrs aren't turned on by default on reiserfs
252                 export MOUNT_OPTIONS="-o acl,user_xattr $REISERFS_MOUNT_OPTIONS"
253                 ;;
254         gfs2)
255                 # acls aren't turned on by default on gfs2
256                 export MOUNT_OPTIONS="-o acl $GFS2_MOUNT_OPTIONS"
257                 ;;
258         tmpfs)
259                 # We need to specify the size at mount, use 512 MB by default
260                 export MOUNT_OPTIONS="-o size=512M $TMPFS_MOUNT_OPTIONS"
261                 ;;
262         *)
263                 ;;
264         esac
265 }
266
267 _test_mount_opts()
268 {
269         case $FSTYP in
270         cifs)
271                 export TEST_FS_MOUNT_OPTS=$CIFS_MOUNT_OPTIONS
272                 ;;
273         *)
274                 ;;
275         esac
276 }
277
278 _mkfs_opts()
279 {
280         case $FSTYP in
281         xfs)
282                 export MKFS_OPTIONS=$XFS_MKFS_OPTIONS
283                 ;;
284         udf)
285                 [ ! -z "$udf_fsize" ] && \
286                         UDF_MKFS_OPTIONS="$UDF_MKFS_OPTIONS -s $udf_fsize"
287                 export MKFS_OPTIONS=$UDF_MKFS_OPTIONS
288                 ;;
289         nfs)
290                 export MKFS_OPTIONS=$NFS_MKFS_OPTIONS
291                 ;;
292         cifs)
293                 export MKFS_OPTIONS=$CIFS_MKFS_OPTIONS
294                 ;;
295         reiserfs)
296                 export MKFS_OPTIONS="$REISERFS_MKFS_OPTIONS -q"
297                 ;;
298         gfs2)
299                 export MKFS_OPTIONS="$GFS2_MKFS_OPTIONS -O -p lock_nolock"
300                 ;;
301         jfs)
302                 export MKFS_OPTIONS="$JFS_MKFS_OPTIONS -q"
303                 ;;
304         *)
305                 ;;
306         esac
307 }
308
309 _fsck_opts()
310 {
311         case $FSTYP in
312         ext2|ext3|ext4|ext4dev)
313                 export FSCK_OPTIONS="-nf"
314                 ;;
315         reiserfs)
316                 export FSCK_OPTIONS="--yes"
317                 ;;
318         *)
319                 export FSCK_OPTIONS="-n"
320                 ;;
321         esac
322 }
323
324 known_hosts()
325 {
326         [ "$HOST_CONFIG_DIR" ] || HOST_CONFIG_DIR=`pwd`/configs
327
328         [ -f /etc/xfsqa.config ]             && export HOST_OPTIONS=/etc/xfsqa.config
329         [ -f $HOST_CONFIG_DIR/$HOST ]        && export HOST_OPTIONS=$HOST_CONFIG_DIR/$HOST
330         [ -f $HOST_CONFIG_DIR/$HOST.config ] && export HOST_OPTIONS=$HOST_CONFIG_DIR/$HOST.config
331 }
332
333 # Returns a list of sections in config file
334 # Each section starts with the section name in the format
335 # [section_name1]. Only alphanumeric characters and '_' is allowed
336 # in the section name otherwise the section will not be resognised.
337 # Section name must be contained between square brackets.
338 get_config_sections() {
339         sed -n -e "s/^\[\([[:alnum:]_]*\)\]/\1/p" < $1
340 }
341
342 if [ ! -f "$HOST_OPTIONS" ]; then
343         known_hosts
344 fi
345
346 export HOST_OPTIONS_SECTIONS="-no-sections-"
347 export OPTIONS_HAVE_SECTIONS=false
348 if [ -f "$HOST_OPTIONS" ]; then
349         export HOST_OPTIONS_SECTIONS=`get_config_sections $HOST_OPTIONS`
350         if [ -z "$HOST_OPTIONS_SECTIONS" ]; then
351                 . $HOST_OPTIONS
352                 export HOST_OPTIONS_SECTIONS="-no-sections-"
353         else
354                 export OPTIONS_HAVE_SECTIONS=true
355         fi
356 fi
357
358 # Parse config section options. This function will parse all the configuration
359 # within a single section which name is passed as an argument. For section
360 # name format see comments in get_config_sections().
361 # Empty lines and everything after '#' will be ignored.
362 # Configuration options should be defined in the format
363 #
364 # CONFIG_OPTION=value
365 #
366 # This 'CONFIG_OPTION' variable and will be exported as an environment variable.
367 parse_config_section() {
368         SECTION=$1
369         if ! $OPTIONS_HAVE_SECTIONS; then
370                 return 0
371         fi
372         eval `sed -e 's/[[:space:]]*\=[[:space:]]*/=/g' \
373                 -e 's/#.*$//' \
374                 -e 's/[[:space:]]*$//' \
375                 -e 's/^[[:space:]]*//' \
376                 -e "s/^\([^=]*\)=\"\?'\?\([^\"']*\)\"\?'\?$/export \1=\"\2\"/" \
377                 < $HOST_OPTIONS \
378                 | sed -n -e "/^\[$SECTION\]/,/^\s*\[/{/^[^#].*\=.*/p;}"`
379 }
380
381 get_next_config() {
382         if [ ! -z "$CONFIG_INCLUDED" ] && ! $OPTIONS_HAVE_SECTIONS; then
383                 return 0
384         fi
385
386         local OLD_FSTYP=$FSTYP
387         local OLD_MOUNT_OPTIONS=$MOUNT_OPTIONS
388         local OLD_TEST_FS_MOUNT_OPTS=$TEST_FS_MOUNT_OPTS
389         local OLD_MKFS_OPTIONS=$MKFS_OPTIONS
390         local OLD_FSCK_OPTIONS=$FSCK_OPTIONS
391
392         unset MOUNT_OPTIONS
393         unset MKFS_OPTIONS
394         unset FSCK_OPTIONS
395         # We might have deduced SCRATCH_DEV from the SCRATCH_DEV_POOL in the previous
396         # run, so we have to unset it now.
397         if [ "$SCRATCH_DEV_NOT_SET" == "true" ]; then
398                 unset SCRATCH_DEV
399         fi
400
401         parse_config_section $1
402
403         if [ ! -z "$OLD_FSTYP" ] && [ $OLD_FSTYP != $FSTYP ]; then
404                 [ -z "$MOUNT_OPTIONS" ] && _mount_opts
405                 [ -z "$TEST_FS_MOUNT_OPTS" ] && _test_mount_opts
406                 [ -z "$MKFS_OPTIONS" ] && _mkfs_opts
407                 [ -z "$FSCK_OPTIONS" ] && _fsck_opts
408         else
409                 [ -z "$MOUNT_OPTIONS" ] && export MOUNT_OPTIONS=$OLD_MOUNT_OPTIONS
410                 [ -z "$TEST_FS_MOUNT_OPTS" ] && export TEST_FS_MOUNT_OPTS=$OLD_TEST_FS_MOUNT_OPTS
411                 [ -z "$MKFS_OPTIONS" ] && export MKFS_OPTIONS=$OLD_MKFS_OPTIONS
412                 [ -z "$FSCK_OPTIONS" ] && export FSCK_OPTIONS=$OLD_FSCK_OPTIONS
413         fi
414
415         # set default RESULT_BASE
416         if [ -z "$RESULT_BASE" ]; then
417                 export RESULT_BASE="$here/results/"
418         fi
419
420         #  Mandatory Config values.
421         MC=""
422         [ -z "$EMAIL" ]          && MC="$MC EMAIL"
423         [ -z "$TEST_DIR" ]       && MC="$MC TEST_DIR"
424         [ -z "$TEST_DEV" ]       && MC="$MC TEST_DEV"
425
426         if [ -n "$MC" ]; then
427                 echo "Warning: need to define parameters for host $HOST"
428                 echo "       or set variables:"
429                 echo "       $MC"
430                 exit 1
431         fi
432
433         echo $TEST_DEV | grep -qE ":|//" > /dev/null 2>&1
434         if [ ! -b "$TEST_DEV" -a "$?" != "0" ]; then
435                 echo "common/config: Error: \$TEST_DEV ($TEST_DEV) is not a block device or a network filesystem"
436                 exit 1
437         fi
438
439         if [ ! -d "$TEST_DIR" ]; then
440                 echo "common/config: Error: \$TEST_DIR ($TEST_DIR) is not a directory"
441                 exit 1
442         fi
443
444         # a btrfs tester will set only SCRATCH_DEV_POOL, we will put first of its dev
445         # to SCRATCH_DEV and rest to SCRATCH_DEV_POOL to maintain the backward compatibility
446         if [ ! -z "$SCRATCH_DEV_POOL" ]; then
447                 if [ ! -z "$SCRATCH_DEV" ]; then
448                         echo "common/config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) should be unset when \$SCRATCH_DEV_POOL ($SCRATCH_DEV_POOL) is set"
449                         exit 1
450                 fi
451                 SCRATCH_DEV=`echo $SCRATCH_DEV_POOL | awk '{print $1}'`
452                 export SCRATCH_DEV
453                 export SCRATCH_DEV_NOT_SET=true
454         fi
455
456         echo $SCRATCH_DEV | grep -qE ":|//" > /dev/null 2>&1
457         if [ ! -z "$SCRATCH_DEV" -a ! -b "$SCRATCH_DEV" -a "$?" != "0" ]; then
458                 echo "common/config: Error: \$SCRATCH_DEV ($SCRATCH_DEV) is not a block device or a network filesystem"
459                 exit 1
460         fi
461
462         if [ ! -z "$SCRATCH_MNT" -a ! -d "$SCRATCH_MNT" ]; then
463                 echo "common/config: Error: \$SCRATCH_MNT ($SCRATCH_MNT) is not a directory"
464                 exit 1
465         fi
466 }
467
468 if [ -z "$CONFIG_INCLUDED" ]; then
469         get_next_config `echo $HOST_OPTIONS_SECTIONS | cut -f1 -d" "`
470         export CONFIG_INCLUDED=true
471
472         # Autodetect fs type based on what's on $TEST_DEV unless it's been set
473         # externally
474         if [ -z "$FSTYP" ] && \
475            [ "$HOSTOS" == "Linux" -o "$OSTYPE" == "linux-gnu" ] && \
476            [ ! -z "$TEST_DEV" ]; then
477                 FSTYP=`blkid -c /dev/null -s TYPE -o value $TEST_DEV`
478         fi
479         FSTYP=${FSTYP:=xfs}
480         export FSTYP
481         [ -z "$MOUNT_OPTIONS" ] && _mount_opts
482         [ -z "$TEST_FS_MOUNT_OPTS" ] && _test_mount_opts
483         [ -z "$MKFS_OPTIONS" ] && _mkfs_opts
484         [ -z "$FSCK_OPTIONS" ] && _fsck_opts
485 fi
486
487 # make sure this script returns success
488 /bin/true